                        org 0x100

                        smsw ax
                        test ax,0x00000001
                        jz goodnov86
                        mov ah,9
                        mov dx,MessageV86
                        int 0x21
                        int 0x20

goodnov86               mov [OldSS],ss
                        mov [OldSP],sp

                        push cs
                        pop word [NextLineSeg]

                        cli

                        ; Initialize descriptors with good bases.
                        xor eax,eax
                        push cs
                        pop ax
                        shl eax,4
                        mov [CodeDesc16.base0_15],ax
                        mov [DataDesc16.base0_15],ax
                        rol eax,16
                        mov [CodeDesc16.base16_23],al
                        mov [DataDesc16.base16_23],al
                        mov [CodeDesc16.base24_31],ah
                        mov [DataDesc16.base24_31],ah
                        rol eax,16
                        ; Now the code and data descriptors are set
                        ; to the beginning of this program.

                        ; Load the 48-bit GDTR (Global Desriptor Table Register)
                        ; with info about where the GDT starts and how long it is.
                        add [PToGDT+2],eax
                        lgdt [PToGDT]

                        ; Switch to Protected Mode
                        mov eax,cr0
                        or al,0x01
                        mov cr0,eax
                        jmp dword 0x0008:Jumpa
                        
Jumpa                   mov ax,0x0010
                        mov ds,ax
                        mov es,ax
                        mov fs,ax
                        mov gs,ax
                        mov ss,ax

                        ; Switch to Real Big Mode...
                        ;
                        ; There's not any real reason to, except that
                        ; my old code used to load a DOS file up past
                        ; the 1MB limit, but I've clipped that out.
                        mov eax,cr0
                        and al,11111110b
                        mov cr0,eax

                        db 0xea
NextLineOff             dw NextLine
NextLineSeg             dw 0

NextLine                mov ax,cs
                        mov ds,ax
                        mov ss,ax
                        mov sp,EndStack
                        sti

                        ; Copy our little program at the 2MB line.
                        mov esi,There
                        xor ax,ax
                        mov es,ax
                        mov edi,0x200000
                        mov ecx,65536
                        rep a32 movsb

                        ; Where are we?
                        xor eax,eax
                        push cs
                        pop ax
                        mov [cs:BzurrroooSeg],ax
                        shl eax,4
                        add eax,ToJump
                        mov [cs:ToJumpOff],eax

                        ; Switch to grafix mode while we have a chance.
                        mov ax,0x0013
                        int 0x10

                        ; Switch Back to Protected Mode
                        cli
                        mov eax,cr0
                        or al,0x01
                        mov cr0,eax
                        db 0x66
                        db 0xea
ToJumpOff               dd 0
ToJumpSeg               dw 0x18

                        bits 32
ToJump                  mov ax,0x20
                        mov ds,ax
                        mov es,ax
                        mov fs,ax
                        mov gs,ax
                        mov ss,ax
                        mov esp,0x1a0000

                        call 0x0018:0x200000

                        ; Go to 16-bit code segment
                        jmp 0x0008:BackToReality

                        bits 16
BackToReality           mov ax,0x10
                        mov ds,ax
                        mov es,ax
                        mov fs,ax
                        mov gs,ax
                        mov ss,ax

                        ; Switch Back to Real Big Mode.
                        ; (nobody will notice).
                        mov eax,cr0
                        and al,0xfe
                        mov cr0,eax
                        db 0xea
BzurrroooOff            dw Bzurrrooo
BzurrroooSeg            dw 0

Bzurrrooo               mov ax,cs
                        mov ds,ax

                        ; Restore the stack, just in case DOS wants it.
                        mov ss,[OldSS]
                        mov sp,[OldSP]

                        ; Set text mode.
                        mov ax,0x0003
                        int 0x10

                        sti

                        mov cx,7
.makenewlines           mov dx,Newline
                        mov ah,0x09
                        int 0x21
                        dec cx
                        jne .makenewlines

                        ; display the bye-bye message
                        ; Warning, spaghetti ahead.
                        mov ax,0xb800
                        mov es,ax
                        mov ah,7
                        xor di,di
                        mov cx,80*25
                        rep stosw

                        xor di,di
                        mov ax,0x0f00+'-'
                        mov cx,80
                        rep stosw

                        mov si,EndMessage
.writeloop1             lodsb
                        mov ah,9
                        stosw
                        cmp al,'y'
                        jne .writeloop1                        

.writeloop2             lodsb
                        mov ah,10
                        stosw
                        cmp al,'r'
                        jne .writeloop2

                        lodsb
.writeloop3             mov ah,9
                        stosw
                        lodsb
                        cmp al,'P'
                        jne .writeloop3

                        mov cx,13
.writeloop4             mov ah,12
                        stosw
                        lodsb
                        dec cx
                        jnz .writeloop4

.writeloop5             mov ah,9
                        stosw
                        lodsb
                        cmp al,13
                        jne .writeloop5

                        mov di,320
.writeloop6             lodsb
                        mov ah,9
                        cmp al,13
                        je .ohsoooo
                        stosw
                        jmp .writeloop6

.ohsoooo                mov di,640
.writeloop7             lodsb
                        mov ah,9
                        stosw
                        cmp al,':'
                        jne .writeloop7

.writeloop8             lodsb
                        mov ah,15
                        cmp al,13
                        je .ohsooooo
                        stosw
                        jmp .writeloop8

.ohsooooo               mov [es:di],byte '.'
                        mov [es:di+1],byte 9
                        mov di,800
.writeloop9             lodsb
                        mov ah,9
                        cmp al,13
                        je .ohsoooooo
                        stosw
                        jmp .writeloop9

.ohsoooooo              mov di,960
                        mov ax,0x0f00+'-'
                        mov cx,80
                        rep stosw
                        int 0x20

                        ; end of spaghetti

PToGDT                  dw 0x27
                        dd GDT
OldSS                   dw 0
OldSP                   dd 0

;;;;;;;;;;;;;;;;;;;;;; Global Descriptor Table ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GDT
DummyDesc               times 8 db 0

CodeDesc16              dw 0xffff
.base0_15               dw 0x0000
.base16_23              db 0x00
                        db 10011010b
                        db 10001111b
.base24_31              db 0x00

DataDesc16              dw 0xffff
.base0_15               dw 0x0000
.base16_23              db 0x00
                        db 10010010b
                        db 10001111b
.base24_31              db 0x00

CodeDesc32              dw 0xffff
.base0_15               dw 0x0000
.base16_23              db 0x00
                        db 10011010b
                        db 11001111b
.base24_31              db 0x00

DataDesc32              dw 0xffff
.base0_15               dw 0x0000
.base16_23              db 0x00
                        db 10010010b
                        db 11001111b
.base24_31              db 0x00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Newline                 db 13,10,'$'
MessageV86              db "This program cannot run in V86 mode. ",13,10,"Try exiting Windows 95 if you are in it, or get rid of EMM386.EXE.$"
EndMessage              db "Coded by Magister. This program is Public Domain. Feel free to share it with",13
                        db "your friends or upload it to a local BBS.",13
                        db "You can contact me at my web site: http://magister.home.ml.org",13
                        db "Tutorials are there on Assembly, C, HTML, CGI with Perl, etc.",13

StartStack              times 1024 db 0
EndStack

There                   incbin "temp.dat"


